use {
	hyper::{
		Request,
		body::Incoming,
		Method,
		StatusCode,
		header::HeaderValue,
	},
	crate::{
		AUTHORIZE_HTML,
		DBPool,
		Result,
		build_html,
		double_split,
		authorize_user,
	},
};


pub async fn authorize(req: Request<Incoming>, pool: DBPool, token: String) -> Result<(String, StatusCode, HeaderValue)> {
	// TODO: Forward for versions.
	if *req.method() == Method::POST {
		let r = double_split(req.uri().query().or(Some("")).unwrap().to_owned(), "&", "=");

		let session = r.get("session");
		let session = match session.is_none() {
			false => session.unwrap().to_owned(),
			_ => "".to_owned()
		};

		if session != "" && session.len() <= 128 {
			authorize_user(pool.clone(), token, session).await;
		}
	}

	let restype: HeaderValue = "text/html".parse().unwrap();
	Ok((build_html(AUTHORIZE_HTML), StatusCode::OK, restype))
}
