use {
	hyper::{
		body::Incoming,
		HeaderMap,
		Method,
		Request,
		header::HeaderValue,
		StatusCode,
	},
	crate::{
		Result,
		DBPool,
		REG_HTML,
		build_html,
		set_location,
		create_user,
		double_split,
		get_body_from_request,
	},
};


pub async fn register(req: Request<Incoming>, pool: DBPool, headers: &mut HeaderMap) -> Result<(String, StatusCode, HeaderValue)> {
	let mut body = "".to_owned();
	let mut status = StatusCode::OK;
	let restype: HeaderValue = "text/html".parse().unwrap();

	if *req.method() == Method::POST {
		let request = get_body_from_request(req).await?;
		let request = String::from_utf8(request).unwrap();
		let request = double_split(request, "&", "=");

		match create_user(pool.clone(), request).await? {
			true => {
				println!("Created");
				set_location(headers, "/login");
			},
			_ => {
				println!("Failed");
				set_location(headers, "/register");
			}
		}

		status = StatusCode::FOUND;
	}
	else {
		body = build_html(REG_HTML);
	}

	Ok((body, status, restype))
}
